CON
  _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000
  pinDataOut = 24    
  pinClock = 23      
  'LED 36,38,....  

PUB Start(BmpAdress)

cognew(@entry,BmpAdress) 

'

DAT           org

'################################################################################################################
'tested OK
entry                                                 ''SHIFTOUT Entry
        mov frqa,#0             ' unecessary
        mov phsa,#0             ' unecessary
        mov ctra,#pinDataOut    ' set the data pin
        movi ctra,#%0_00100_000 ' set the mode to NCO, single output pin
        ' set up Counter B to be the clock counter
        mov frqb,#0             ' unecessary
        mov phsb,#0             ' unecessary
        mov ctrb,#pinClock      ' set the clock pin
        movi ctrb,#%0_00100_000 ' set the mode to NCO, single output pin
        mov t,#1                ' temp = 1
        shl t,#pinDataOut       ' temp = 1 << pinDataOut
        mov dira,t              ' DIRA now has the DataOut pin as an output
        mov t,#1                ' temp = 1
        shl t,#pinClock         ' temp = 1 << pinClock
        or dira,t               ' DIRA now has both DataOut and Clock as outputs

         mov     PxlDly_pointer,par
        add     PxlDly_pointer,#4
        mov     run_cog2_pointer,par
        mov     offset_rot_pointer,par
        add     offset_rot_pointer,#8
               mov     ArrayStartAddress ,par
               mov     ArrayEndAddress,ArrayStartAddress
               add     ArrayEndAddress, offset
               mov     PxlDly_pointer,par
               add     PxlDly_pointer,array_offset
               'add     ArrayEndAddress,#1
loop           mov     LedPointer,    par       'Pointer to Bmp Address
               add     LedPointer,offset_threequarterRound 'start at opposite
              WAITPEQ low,#1       'wait for
              WAITPEQ high,#1               ' new round

              mov     row,  #120
new_row         

              ' inner Loop
'-----------------------------------------------------------------------------                                  
              call    #StartFrame   
              mov     line,  #6
new_line      mov     lineSeg, #6
new_line_seg   

            

               rdbyte  temp,LedPointer    'get the pixel to show
               ror     temp,#4   ' 4 MSBs, color for even pixels 
               mov    table_ptr,#color_table
               add   table_ptr, temp
               movs :lookup,table_ptr     'magic :-)
               nop                        'wait for pipelining
 :lookup       mov table_ptr,0-0          'get the 24 bit color from 4 bit color table

               call #eight_ones          '11111111 then comes 24 bit color
               'mov t3,color_table 
               mov t,#23                ' number of bits left        
               mov phsa,table_ptr          ' start with the raw data byte
               shl phsa,#8            ' get the MSb into position 31
               'rev phsa,#0            ' do this instead of the above line for LSb first
               movi phsb,#%011000000   ' set up my clock register         
               movi frqb,#%001000000   ' start my clock line ticking!
:bit_shift_loop
               shl phsa,#1             ' move next bit into the PHSA[31] slot
               djnz t,#:bit_shift_loop ' keep going till we run out of bits
               mov frqb,#0    ' stop my clock

              

                             
               sub     LedPointer,    #1          'next pixel
    
               djnz    lineSeg,#new_line_seg

          

             
              sub     LedPointer,#348 'next segment 120/24 x 72  -12   
              cmps    LedPointer,ArrayStartAddress      wc    'LEDPointer < arrayStart - wrap around ?
   if_c       add     LedPointer,offset        'then add 10368  - whole array

                   
              djnz    line,#new_line
                            
              call    #StopFrame
              call    #PixelDelay
             

'-----------------------------------------------------------------------------                    
               ' inner Loop   

              add     LedPointer,SixSegBack
              cmps    LedPointer, ArrayEndAddress     wc , wz  'wrap around ?
if_nc_and_nz  sub     LedPointer,offset        'then sub 10368  - whole array
             ' sub    LedPointer,    #1

              djnz    row,#new_row
                   
               
              jmp     #loop                          ''     Go wait for next round





'--------------------------------------------------------------------------------------------------

'                        SUBROUTINES
'----------------------------------------------------------------------------------------


eight_ones
        mov t,#7                ' number of bits left        
        mov phsa,#255          ' start with the raw data byte
        shl phsa,#24            ' get the MSb into position 31
        'rev phsa,#0            ' do this instead of the above line for LSb first
        movi phsb,#%011000000   ' set up my clock register         
        movi frqb,#%001000000   ' start my clock line ticking!
:bit_shift_loop2
        shl phsa,#1             ' move next bit into the PHSA[31] slot
        djnz t,#:bit_shift_loop2 ' keep going till we run out of bits
        mov frqb,#0    ' stop my clock     ' stop my clock
eight_ones_ret    ret

'------------------------------------------------------------------------------------------------

StartFrame
        mov     t3,             #4            ''      
StartX4
        mov t,#7                ' number of bits left        
        mov phsa,#%00000000         ' start with the raw data byte
        shl phsa,#24            ' get the MSb into position 31
        'rev phsa,#0            ' do this instead of the above line for LSb first
        movi phsb,#%011000000   ' set up my clock register         
        movi frqb,#%001000000   ' start my clock line ticking!
:bit_shift_loop3
        shl phsa,#1             ' move next bit into the PHSA[31] slot
        djnz t,#:bit_shift_loop3 ' keep going till we run out of bits
        mov frqb,#0    ' stop my clock  ' stop my clock            ''          Restore ClockPin to original read value                       ''          Send clock pulse
        djnz    t3,             #StartX4         ''          4 times
StartFrame_ret ret


'----------------------------------------------------------------------------------------------

StopFrame
              

        mov     t3,             #4
StopX4  mov t,#7       
        mov phsa,#%11111111         ' start with the raw data byte
        shl phsa,#24            ' get the MSb into position 31
        'rev phsa,#0            ' do this instead of the above line for LSb first
        movi phsb,#%011000000   ' set up my clock register         
        movi frqb,#%001000000   ' start my clock line ticking!
:bit_shift_loop44
        shl phsa,#1             ' move next bit into the PHSA[31] slot
        djnz t,#:bit_shift_loop44 ' keep going till we run out of bits
        mov frqb,#0    ' stop my clock  ' stop my clock
        djnz    t3,             #StopX4         ''                 
StopFrame_ret ret

             



'------------------------------------------------------------------------------------------------------------------------------

PixelDelay 
              mov       t6,     Delay
PxlPause      djnz      t6,     #PxlPause                               
PixelDelay_ret ret





'--------------------------------------------------------------------------------------------------
'                MSB   B         G         R  LSB

color_table   long %00000000_00000000_00000000  'black              0
              long %00000000_00000000_10000000   'red
              long %00000000_10000000_00000000   'green
              long %11111111_00000000_00000000   'blue
              long %00000000_01000000_01000000   'yellow
              long %01000000_01000000_00000000   'cyan
              long %01000000_00000000_01000000   'magenta
              long %10000000_00010000_00100000    'purple
              long %01000000_00010000_01000000    'pink
              long %00000000_00100000_10000000    'orange
              long %00000010_01000000_00100000    'yellow green
              long %10000000_01000000_00100000    'sky blue
              long %00100000_01000000_10000000    'sandy
              long %10000000_01000000_01000000    'lavender
              long %00010000_00010000_00010000   'grey
              long %01000000_01000000_01000000  'white               15















 

row                      long   0
line                     long   0
lineSeg                  long   0

PxlDly                   long   0

low                      long 0
high                     long 1

PxlDly_pointer           long 0
LedPointer               long 0
offset                   long 8640 
offset_threequarterRound long 2201'
t                       long    0                       ''temp variables
t1                      long    0                       ''     Used for DataPin mask      
t2                      long    0                       ''     Used for CLockPin mask    
t3                      long    0                       ''     Used to hold DataValue SHIFTIN/SHIFTOUT
t4                      long    0                       ''     Used to hold # of Bits
t5                      long    0                       ''     Used for temporary data mask
t6                      long    0                       ''     Used for Clock Delay
t7                      long    0
run_cog2                long  0
run_cog2_pointer         long 0
SixSegBack              long 2196 '( 5 Pixel x 5 Seg + 1 Seg x 72 - 24 )      -beginning of next Seg
offset_rot_pointer      long 0
offset_rot              long 0
Reference_ptr            long 0
delay                   long 2000
temp                    long 0
table_ptr                 long 0

ArrayStartAddress       long 0
ArrayEndAddress         long 0
array_offset            long $1000
diff                    long $6000
fit          